#pragma once

#include "../../ecs_component.h"
#include "../../component/component_game_object.h"
#include "../../component/action/component_action_return.h"
#include "../../component/action/component_action_redirect.h"
#include "../../component/action/component_action_on_delete_give_ammo.h"
#include "../../component/action/component_action_lock.h"
#include "../../component/action/component_action_damage.h"

#define SNAKE_SPEED 1
#define SNAKE_FRICTION 1
#define SNAKE_VELOCITY_MAX 15
#define SNAKE_ACTION_RETURN_SPEED 1
#define SNAKE_ACTION_RETURN_VELOCITY_MAX 20
#define SNAKE_ACTION_RETURN_LIFETIME 20
#define SNAKE_ACTION_DAMAGE_VALUE 1
#define SNAKE_ACTION_RETURN_MULTIPLIER 1.15
#define SNAKE_ACTION_ON_DELETE_GIVE_AMMO_VALUE 1
#define SNAKE_ACTION_REDIRECT_MULTIPLIER 1.15
#define SNAKE_ALLEGIANCE ALLEGIANCE_PLAYER
#define SNAKE_ACTION_LOCK_SELECT_RADIUS 100.0f
#define SNAKE_ACTION_LOCK_COOLDOWN 300

static const vec2 SNAKE_SIZE = {25.0f, 25.0f};
static const vec2 SNAKE_PHYSICS_SIZE = {25.0f, 25.0f};
static const vec3 SNAKE_OFFSET = {0.0f, -50.0f, 0.0f};

void entity_snake_init(ECS* ecs, u32 id, vec3 position, u32 sender);
